CREATE OR REPLACE PROCEDURE REPLICA_CARDAPIO_PLA 
(
	P_DTCARDORI IN DATE,
	P_SERVICOS IN VARCHAR2,
	P_MAPADIAS IN VARCHAR2,
	P_CDOPERADOR IN VARCHAR2,
	P_CDFILIALLOGADA IN VARCHAR2,
	P_NRORG IN NUMBER,
	P_LISTAERROS OUT NUMBER
)
AS
	V_NRORDEM_ERROS NUMBER;
	V_RECEITA_UTILIZADA VARCHAR2(1);
	V_IDCARDIAUTIL VARCHAR2(1);
	V_IDATIVO VARCHAR2(1);
   V_CDARVPROD VARCHAR2(20);
   V_NMPRODUTO VARCHAR2(50);
   V_PRATO_INATIVO VARCHAR2(1);
	V_RECEITA_INATIVA VARCHAR2(1);
	V_PRODUTO_INATIVO VARCHAR2(1);
	V_ULTDIA_DTCARDORI DATE;
	V_CDCHAVE VARCHAR2(500);
	V_IDUTRPADCA VARCHAR2(1);
	V_SOMENTE_VALIDACAO VARCHAR2(1);
	-- Procedure auxiliar para agilizar incluso na lista de erros
   PROCEDURE I_L(MENSAGEM IN VARCHAR2)
   AS   
   BEGIN
   	V_NRORDEM_ERROS := V_NRORDEM_ERROS + 1;
      INSERE_LISTA_ERROS(P_CDFILIALLOGADA, MENSAGEM,
                         P_CDOPERADOR, P_NRORG, P_LISTAERROS,
                         V_NRORDEM_ERROS, V_CDCHAVE);
   END;
BEGIN
	V_NRORDEM_ERROS := 0;

	-- Parmetros do sistema
    
	-- Parmetros gerais
   SELECT MAX(IDUTRPADCA)
   INTO   V_IDUTRPADCA
   FROM   PARAMGERAL;
      
   V_IDUTRPADCA := NVL(V_IDUTRPADCA, 'N');
   V_ULTDIA_DTCARDORI := LAST_DAY(P_DTCARDORI);
   
   -- Percorre os servios a replicar
   
	FOR C_SERVICOS IN
	(
		SELECT S.CDFILIAL, S.CDSERVFILI
		  FROM LISTA L
		       INNER JOIN SERVICO S ON S.CDFILIAL = SUBSTR(CDLISTA, 1, 4) AND
                                     S.CDSERVFILI = SUBSTR(CDLISTA, 6, 5)
		 WHERE L.NRLISTA = P_SERVICOS
		 ORDER BY S.CDFILIAL, S.CDSERVFILI
	) LOOP

		V_CDCHAVE := C_SERVICOS.CDFILIAL || '|' || C_SERVICOS.CDSERVFILI || '|' || TO_CHAR(P_DTCARDORI, 'YYYYMMDD') || '|' || 'O';

		V_RECEITA_UTILIZADA := NULL;
		V_PRATO_INATIVO  := 'N';
		V_RECEITA_INATIVA := 'N';
		V_PRODUTO_INATIVO := 'N';
        
	  -- Percorre os pratos da origem
       
		FOR C_PRATOS IN
		(
			SELECT DISTINCT P.CDFILAUXPRAT, P.CDPRATO,                      
                P.CDPRATO || ' - ' || P.NMPRATO AS NMPRATO,
                P.IDATIVO
           FROM COMPCARD C
                LEFT JOIN PRATO P ON P.CDFILAUXPRAT = C.CDFILAUXPRAT AND
                                     P.CDPRATO = C.CDPRATO
                WHERE C.CDFILIAL = C_SERVICOS.CDFILIAL
                  AND EXISTS (
				                  	SELECT 1
				                  	  FROM CARDADIA CARD
				                  	 WHERE CARD.CDFILIAL = C_SERVICOS.CDFILIAL
				                  	   AND CARD.CDSERVFILI = C_SERVICOS.CDSERVFILI
				                  	   AND CARD.DTCARDAPIO BETWEEN P_DTCARDORI AND V_ULTDIA_DTCARDORI
				                  	   AND CARD.CDFILIAL = C.CDFILIAL
				                  	   AND CARD.NRCARDAPIO = C.NRCARDAPIO
                      )
		) LOOP	
        
			-- Validaes do prato - Receita utilizada e prato inativo
            
			V_RECEITA_UTILIZADA := RECEITA_UTILIZADA(C_PRATOS.CDPRATO, C_PRATOS.CDFILAUXPRAT,  C_SERVICOS.CDFILIAL, C_SERVICOS.CDSERVFILI);
			IF V_RECEITA_UTILIZADA IS NULL OR V_RECEITA_UTILIZADA = '' THEN
				-- Prato __PARAM0__ no possui receita
				I_L(MSG('SEM_RECEITA', C_PRATOS.NMPRATO));
			END IF;

			IF V_IDUTRPADCA = 'N' AND V_RECEITA_UTILIZADA = 'P' THEN
				-- Prato __PARAM0__ possui apenas receita padro e unidade requer receita local
				I_L(MSG('SOMENTE_RECEITA_PADRAO', C_PRATOS.NMPRATO));
			END IF;

			IF C_PRATOS.IDATIVO = 'N' THEN
				-- Prato __PARAM0__ est inativo
				I_L(MSG('PRATO_INATIVO', C_PRATOS.NMPRATO));
				V_PRATO_INATIVO := 'S';
			END IF;

			IF V_RECEITA_UTILIZADA = 'P' THEN
			   SELECT MAX(IDATIVO)
			     INTO V_IDATIVO
              FROM PRATPADR
             WHERE CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
               AND CDPRATO = C_PRATOS.CDPRATO;
            IF V_IDATIVO = 'N' THEN
            	-- Receita padro do prato __PARAM0__ est inativa
					I_L(MSG('RECEITA_PADRAO_INATIVA', C_PRATOS.NMPRATO));
					V_RECEITA_INATIVA := 'S';
				END IF;
			ELSIF V_RECEITA_UTILIZADA = 'F' THEN
			   SELECT MAX(IDATIVO)
			     INTO V_IDATIVO
              FROM PRATFILI
             WHERE CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
               AND CDPRATO = C_PRATOS.CDPRATO
               AND CDFILIAL = C_SERVICOS.CDFILIAL;
            IF V_IDATIVO = 'N' THEN
            	-- Receita local do prato __PARAM0__ est inativa
					I_L(MSG('RECEITA_LOCAL_INATIVA', C_PRATOS.NMPRATO));
					V_RECEITA_INATIVA := 'S';
				END IF;
			ELSIF V_RECEITA_UTILIZADA = 'S' THEN
				SELECT MAX(IDATIVO)
				  INTO V_IDATIVO
              FROM PRATSERV
             WHERE CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
               AND CDPRATO = C_PRATOS.CDPRATO
               AND CDFILIAL = C_SERVICOS.CDFILIAL
               AND CDSERVFILI = C_SERVICOS.CDSERVFILI;
            IF V_IDATIVO = 'N' THEN
            	-- Receita por servio do prato __PARAM0__ est inativa
					I_L(MSG('RECEITA_SERVICO_INATIVA', C_PRATOS.NMPRATO));
					V_RECEITA_INATIVA := 'S';
				END IF;
			END IF;
            
			-- Validaes dos produtos do prato - Produto inativo, receita inativa
            
			FOR C_PRODUTOS IN
			(SELECT R.CDPRODUTO
				FROM RECEPADR R
			  WHERE R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
			    AND R.CDPRATO = C_PRATOS.CDPRATO
			    AND V_RECEITA_UTILIZADA = 'P'
			  UNION ALL
			 SELECT R.CDPRODUTO
				FROM RECEFILI R
			  WHERE R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
			    AND R.CDPRATO = C_PRATOS.CDPRATO
			    AND R.CDFILIAL = C_SERVICOS.CDFILIAL
			    AND V_RECEITA_UTILIZADA = 'F'
			  UNION ALL
			 SELECT R.CDPRODUTO
				FROM RECESERV R
			  WHERE R.CDFILAUXPRAT = C_PRATOS.CDFILAUXPRAT
			    AND R.CDPRATO = C_PRATOS.CDPRATO
			    AND R.CDFILIAL = C_SERVICOS.CDFILIAL
			    AND R.CDSERVFILI = C_SERVICOS.CDSERVFILI
			    AND V_RECEITA_UTILIZADA = 'S'
			) LOOP
				SELECT MAX(IDPRODATIVPR), MAX(CDARVPROD), MAX(NMPRODUTO)
				  INTO V_IDATIVO, V_CDARVPROD, V_NMPRODUTO
				  FROM PRODUTO
				 WHERE CDPRODUTO = C_PRODUTOS.CDPRODUTO;
				IF NVL(V_IDATIVO, 'S') <> 'N' THEN
					SELECT MAX(IDPRODATIV)
					  INTO V_IDATIVO
					  FROM PRODFILI
					 WHERE CDPRODUTO = C_PRODUTOS.CDPRODUTO
					   AND CDFILIAL = C_SERVICOS.CDFILIAL;
				END IF;
				V_IDATIVO := NVL(V_IDATIVO, 'S');
				IF V_IDATIVO = 'N' OR V_IDATIVO = 'I' THEN
					IF V_RECEITA_UTILIZADA = 'P' THEN
						-- Produto __PARAM0__ da receita padro do prato __PARAM1__ est inativo
						I_L(MSG('PRODUTO_PADRAO_INATIVO', C_PRATOS.NMPRATO, V_CDARVPROD || ' - ' || V_NMPRODUTO));
					ELSIF V_RECEITA_UTILIZADA = 'F' THEN
						-- Produto __PARAM0__ da receita local do prato __PARAM1__ est inativo
						I_L(MSG('PRODUTO_LOCAL_INATIVO', C_PRATOS.NMPRATO, V_CDARVPROD || ' - ' || V_NMPRODUTO));
					ELSIF V_RECEITA_UTILIZADA = 'S' THEN
						-- Produto __PARAM0__ da receita por servio do prato __PARAM1__ est inativo
						I_L(MSG('PRODUTO_SERVICO_INATIVO', C_PRATOS.NMPRATO, V_CDARVPROD || ' - ' || V_NMPRODUTO));
					END IF;
					V_PRODUTO_INATIVO := 'S';
				END IF;
			END LOOP;
		END LOOP;
        
	    -- Percorre os meses de destino
      
		-- A origem tem que estar OK para replicar aos destinos
		V_SOMENTE_VALIDACAO := 'N';
		IF (V_RECEITA_UTILIZADA IS NULL OR 
			 V_RECEITA_UTILIZADA = '' OR
			 V_PRATO_INATIVO <> 'N' OR
			 V_RECEITA_INATIVA <> 'N' OR
			 V_PRODUTO_INATIVO <> 'N') THEN
			V_SOMENTE_VALIDACAO := 'S';
		END IF;

		FOR C_MESES IN
		(
			SELECT DTMES
			  FROM
						( 
							SELECT DISTINCT TO_DATE(SUBSTR(CDLISTA, 1, 6), 'YYYYMM') AS DTMES
							  FROM LISTA L
							 WHERE L.NRLISTA = P_MAPADIAS
						)
			 ORDER BY DTMES
		) LOOP		
			REPLICA_SERVICO_CARD_PLA(P_DTCARDORI, C_SERVICOS.CDFILIAL, C_SERVICOS.CDSERVFILI, 
				                      C_MESES.DTMES, P_MAPADIAS, P_CDOPERADOR, 
				                      P_CDFILIALLOGADA, P_NRORG, V_SOMENTE_VALIDACAO,
				                      V_NRORDEM_ERROS, P_LISTAERROS);
		END LOOP;				
	END LOOP;
END;
/