function importacaArquivoXml() {
    const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
    const z = new ZeedhiAPIConstructor(browser, protractor);
    const Helper = require('teknisa-helper');
    const geralPage = new Helper.geral();
    const protractorHelper = require('protractor-helper');
    const j = require('../../../../json/leitorJsonHela.po');
    const self = this;

    this.abrir = () => {
        z.component.menu.open();
        protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
        z.component.menu.clickByPath(['Documentos Fiscais', 'Entradas', 'Lançamentos', 'Importação/Consulta de Notas Fiscais (Arquivo XML)']);
        geralPage.esperarLoading();
    };

    this.filtroInicial = () => {
        geralPage.selectNative('TCDFILIAL', 'Todos');
        geralPage.selectNative('TCDINSCESTA', 'Todos');
        browser.sleep(2500);
        z.field.calendar.selectIntervalDate('DTEMISSAO', j.getValor('dtiniemissxml'), j.getValor('dtfinemissxml'), 'pt_br');
        browser.sleep(3000);
    };

    this.uploadXml = () => {
        //Clica no botão upload
        z.component.footer.clickCenterActionByLabel('Upload');

        //Localiza e seleciona arquivo.
        var path = require('path');
        var fileToUpload = '../../../../upload/35200859105635000368551350000051031000001444-nfe.xml',
            absolutePath = path.resolve(__dirname, fileToUpload);
        $('input[type="file"]').sendKeys(absolutePath);
        browser.sleep(5000);

        //Clica no segundo botão 'Upload' para baixar arquivo.
        var elementos = element.all(by.css('#footer > div.zh-footer-right'));
        elementos.each(function (el) {
            el.isDisplayed().then(function (displayed) {
                if (displayed) {
                    try {
                        el.click();
                    } catch (erro) {
                        console.log(erro);
                    }
                }
                browser.sleep(3000);
            });
        });
    };

    this.refreshWidget = () => {
        z.component.floatingControl.open();
        z.component.floatingControl.selectAction('refresh');
        browser.sleep(2500);
        geralPage.filterIt(j.getValor('nracessonfe'));
        browser.sleep(2500);
    };

    this.editarFilial = () => {
        geralPage.clickGrid('NRACESSONFE', j.getValor('nracessonfe'), '4037041933179304567641', false);
        geralPage.clickEditar();
        geralPage.searchAndClickGridField('NMFILIRECE', j.getValor('nmfilirece'), 'NMFILIAL');
        geralPage.clickSalvar();
        z.component.floatingControl.open();
        z.component.floatingControl.selectAction('refresh');
        geralPage.filterIt(j.getValor('nmfilirece'));
    };
}
module.exports = new importacaArquivoXml();
