const { browser } = require('protractor');
const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../json/leitorJsonHela.po.js');
const transmissaoVendaPage = require('../../../../page-objects/documentosfiscais/saidas/notafiscaleletronica/transmissaoVenda.po.js');


const gridTransmissaoVenda = '11340831634164007254492';
const gridAtualizaLote = '11340831611600310704493';

describe('Transmissão de Nota Fiscal de Venda', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'), j.getValor('url'));
        transmissaoVendaPage.abrir();
        transmissaoVendaPage.filtroLancamentoVenda(j.getValor('unidadeVenda'), j.getValor('statusCancelada'), j.getValor('statusUsoDenegado'), j.getValor('destinatarioVenda'));
        transmissaoVendaPage.selectIntervalDate('DTENTRSAID', j.getValor('dataInicialVenda'), j.getValor('dataFinalVenda'), 'pt_br');
        geral.clickAplicarFiltro();
        browser.sleep(4000);
    });

    afterAll(() => {
        geral.sair();
    });

    it('Acessar tela de Transmissão de Nota Fiscal Eletrônica', () => {
        geral.esperarLoading();

        expect(z.component.header.getTitle())
        .toBe('Transmissão de NF-e');
    });

    it('Transmitir nota fiscal de venda', () => {
        var order = element(by.css('#grid-11340831634164007254492 > div.header > div > div > div:nth-child(4) > span > span.ng-binding'));
        var checkbox = element(by.css('#grid-11340831634164007254492 > div.body > div > div:nth-child(1) > div.td.grid-checkbox-column.zh-side-column.fixed.zh-ripple-effect'));
        var checkboxLote = element(by.css('#grid-11340831611600310704493 > div.body > div > div.tr.cell1 > div.td.grid-checkbox-column.zh-side-column.fixed.zh-ripple-effect > span > svg > rect'));
        protractorHelper.click(order);
        protractorHelper.click(checkbox);
        geral.clickTransmitir();
        z.component.alert.isVisible().then(function(schemaXml) {
            if(schemaXml) {
                z.component.alert.getText().then(function(xmlInvalid) {
                    console.log(xmlInvalid);
                });
            }            
        });
        browser.sleep(4000);
        geral.clickOk();

        expect(geral.gridHasText(gridTransmissaoVenda, j.getValor('statusTransmitida'), 7, true))
            .toEqual('Transmitida');
            
        geral.clickAcoes();
        geral.clickActionPorIndice('1');
        protractorHelper.click(checkboxLote);
        geral.clickAtualizarLote();
        geral.clickOk();
        z.widget.grid.getText(gridTransmissaoVenda, 0, 7, true).then(function (statusTransmissao) {
            if (statusTransmissao === j.getValor('statusAceita')) {
                expect(geral.gridHasText(gridTransmissaoVenda, j.getValor('statusAceita'), 7, true))
                    .toEqual('Aceita');
            } else {
                geral.clickGrid('IDSTATUSNFE', j.getValor('statusRejeitada'), gridTransmissaoVenda);
                geral.getFieldValue('DSOBSSTATUSNFE').then(function (mensagem) {
                    console.log(mensagem);
                });
            }
        })
    });
});